package battleshipsAssignment;

import javafx.application.Application;

import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.input.MouseEvent;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;


public class BattleshipGame extends Application {

	Rectangle[][] player = new Rectangle[10][10];
	Rectangle[][] computer = new Rectangle[10][10];
	int[][] computerShips = new int[10][10];
	Patrol patrol = new Patrol();
	Destroyer destroyer = new Destroyer();
	Battleship battleship = new Battleship();
	Aircraft aircraft = new Aircraft();
	Group group = new Group();
	Label playerboard = new Label("Your board");
	Label opponentboard = new Label("Opponent's board");
	Button startbutton = new Button("Start game!");
	Button patrolbutton = new Button("Patrol ships (2 Squares) " + patrol.amount + " left");
	Button destroyerbutton = new Button("Destroyer ships (3 Squares) " + destroyer.amount + " left");
	Button battleshipbutton = new Button("Battleships (4 Squares) " + battleship.amount + " left");
	Button aircraftbutton = new Button("Aircraft Carriers (5 Squares) " + aircraft.amount + " left");
	Label patrolGone = new Label("All Patrol ships have been destroyed!");
	Label destroyerGone = new Label("All Destroyer ships have been destroyed!");
	Label battleshipGone = new Label("All Battleship ships have been destroyed!");
	Label aircraftGone = new Label("All Aircraft ships have been destroyed!");
	Label instructions = new Label(
			"Click the corresponding buttons on the left to choose the ship you want to place, \n"
					+ "then click the square on the player board you would like it to occupy. \n"
					+ "Once all ships are placed click the start button to start playing. \n"
					+ "Click the opponent's board to fire, the opponent will automatically fire back. \n"
					+ "Red indicates a hit, grey indicates a miss.");
	int activeButton = 0;

	boolean activeGame = false;

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		launch(args);
	}

	public void start(Stage stage) throws Exception {

		group.getChildren().addAll(opponentboard, playerboard, startbutton, patrolbutton, destroyerbutton,
				battleshipbutton, aircraftbutton, patrolGone, destroyerGone, battleshipGone, aircraftGone,
				instructions);
		instructions.setLayoutX(700);
		instructions.setLayoutY(80);
		patrolGone.setLayoutX(700);
		patrolGone.setLayoutY(450);
		destroyerGone.setLayoutX(700);
		destroyerGone.setLayoutY(470);
		battleshipGone.setLayoutX(700);
		battleshipGone.setLayoutY(490);
		aircraftGone.setLayoutX(700);
		aircraftGone.setLayoutY(510);
		patrolGone.setVisible(false);
		destroyerGone.setVisible(false);
		battleshipGone.setVisible(false);
		aircraftGone.setVisible(false);
		playerboard.setLayoutX(470);
		playerboard.setLayoutY(730);
		opponentboard.setLayoutX(470);
		opponentboard.setLayoutY(80);
		startbutton.setLayoutY(50);
		patrolbutton.setLayoutY(100);
		destroyerbutton.setLayoutY(150);
		battleshipbutton.setLayoutY(200);
		aircraftbutton.setLayoutY(250);
		patrolbutton.setOnMouseClicked(e -> {
			activeButton = 1;
		});
		destroyerbutton.setOnMouseClicked(e -> {
			activeButton = 2;
		});
		battleshipbutton.setOnMouseClicked(e -> {
			activeButton = 3;
		});
		aircraftbutton.setOnMouseClicked(e -> {
			activeButton = 4;
		});

		for (int y = 0; y < 10; ++y) {
			for (int x = 0; x < 10; ++x) {

				Rectangle r2 = new Rectangle();
				Rectangle r = new Rectangle();
				player[x][y] = r2;
				computer[x][y] = r;

				final int x1 = x;
				final int y1 = y;

				r.setLayoutX(350);
				r.setLayoutY(100);
				r.setFill(Color.WHITE);
				r.setStroke(Color.BLACK);
				r.setX(30 * x);
				r.setY(30 * y);
				r.setWidth(30);
				r.setHeight(30);

				r2.setLayoutX(350);
				r2.setLayoutY(420);
				r2.setFill(Color.WHITE);
				r2.setStroke(Color.BLACK);
				r2.setX(30 * x);
				r2.setY(30 * y);
				r2.setWidth(30);
				r2.setHeight(30);

				r2.setOnMouseClicked(new EventHandler<MouseEvent>() {
					@Override

					public void handle(MouseEvent a) {
						// patrol ship deployment

						if ((activeButton == 1) && (patrol.amount > 0)) {
							patrol.playerShipCreate(a, r2, patrolbutton, player, x1, y1);

						}

						// Destroyer ships deployment
						else if ((activeButton == 2) && (destroyer.amount > 0)) {
							destroyer.playerShipCreate(a, r2, destroyerbutton, player, x1, y1);

						}
						// battleship deployment
						else if ((activeButton == 3) && (battleship.amount > 0)) {
							battleship.playerShipCreate(a, r2, battleshipbutton, player, x1, y1);

						}
						// aircraft carrier deployment
						else if ((activeButton == 4) && (aircraft.amount > 0)) {
							aircraft.playerShipCreate(a, r2, aircraftbutton, player, x1, y1);

						}

						// No ships left
						else if ((activeButton == 1) && (patrol.amount == 0)) {
							Alert amountError = new Alert(AlertType.ERROR);
							amountError.setContentText("No patrol ships left! Please select new ship");
							amountError.showAndWait();
						} else if ((activeButton == 2) && (destroyer.amount == 0)) {
							Alert amountError = new Alert(AlertType.ERROR);
							amountError.setContentText("No Destroyer ships left! Please select new ship");
							amountError.showAndWait();
						} else if ((activeButton == 3) && (battleship.amount == 0)) {
							Alert amountError = new Alert(AlertType.ERROR);
							amountError.setContentText("No  Battleships left! Please select new ship");
							amountError.showAndWait();
						} else if ((activeButton == 4) && (aircraft.amount == 0)) {
							Alert amountError = new Alert(AlertType.ERROR);
							amountError.setContentText("No Aircraft Carriers left! Please select new ship");
							amountError.showAndWait();
						}
						// No ship selected
						else {
							Alert selectError = new Alert(AlertType.ERROR);
							selectError.setContentText("No ship selected!");
							selectError.showAndWait();
						}
					}
				});

				group.getChildren().addAll(r2, r);
			}

		}

		startbutton.setOnMouseClicked(e -> {
			if ((patrol.amount != 0) || (destroyer.amount != 0) || (battleship.amount != 0) || (aircraft.amount != 0)) {
				Alert amountError = new Alert(AlertType.ERROR);
				amountError.setContentText("Place all ships first");
				amountError.showAndWait();
			} else {
				activeGame = true;
				activeButton = 0;
				startbutton.setDisable(true);
				ComputerPlacement.computerCreateShips(computer, computerShips);
				for (int x = 0; x < 10; x++) {
					for (int y = 0; y < 10; y++) {
						LiveGame.game(computer[x][y], player, computerShips, x, y, stage, patrolGone,destroyerGone,battleshipGone,aircraftGone);
					}
				}

			}

		});

		Scene scene = new Scene(group, 1200, 800, Color.WHITE);
		stage.setX(50);
		stage.setY(50);
		stage.setScene(scene);

		stage.show();

	}

}